# Souplesse

_This readme describes what may someday be, not what is today_

Reads a GPX file which you generated by cycling around, and tells you
interesting(sic) things about it.

The principle we aspire to is that the measurement is subsidary to the
ride, not the purpose of the ride. The purpose of the ride is to enjoy
cycling, or to see new places, or to get from A to B, and the purpose
of Souplesse is to see if we can get any useful numbers out of the
riding you were doing anyway without making you do more of it.

So, the general idea is that given some ride data it can tell you how
long/how often you spent at a given level of effort (e.g. heart rate),
or output (power, speed, cadence, rate of ascent).

## Canned views

### ride view

graph of (selected variables) / time, with buttons to select variables
slider for threshold level
all points above threshold are highlighted and interval times above
 threshold shown
zoom in/out on time range
show the selected points on a map

### calendar view

note this will need some kind of server-side storage so that the
system remembers all your gpx files

shows dates that you rode
for each ride, show time at effort
some kind of slider for effort level


## Query view

Not yet decided if this is useful, something that allows graphs of
arbitrary functions of properties (e.g. to look at power/cadence
ratio, or ... some other weirdness)


# Tech notes

Run tests with `cabal test --test-show-details=always`: if you don't
ask for details it won't tell you about incomplete pattern matches


----

_Do not look below this line_

## WIP, Puzzles and TODO

* [done] Pos can't include elevation if it's sometimes unknown
* do we even need Track? will it ever be anything more than a collection
 of Points?
* [done] need a real gpx file with namespace decls before we can parse power and stuff
* tests seem to pass without <gpx> element?
* stop returning bogus data when missing required elements (e.g. time)
